version: '3.9'
#https://github.com/ghotiphud/rust-web-starter
services:
  postgres:
    image: 'postgres:alpine'
    container_name: postgres
    command: ["postgres", "-c", "log_statement=all"]
    ports:
      - "5432:5432"
    healthcheck:
      test: ["CMD-SHELL", "pg_isready -U efb"]
      interval: 10s
      timeout: 5s
      retries: 5
    environment:
      - POSTGRES_USER=efb
      - POSTGRES_PASSWORD=efb
      - POSTGRES_HOST_AUTH_METHOD=password
      - PGDATA=/var/lib/postgresql/data/pgdata
  rocket:
    container_name: rocket
    build: ./backend
    volumes:
      #- $HOME/.cargo/bin:/usr/local/cargo/bin/
      - ./backend/src:/efb-backend/src
      - ./backend/Cargo.toml:/efb-backend/Cargo.toml
      - ./backend/Rocket.toml:/efb-backend/Rocket.toml
      - ./backend/Cargo.lock:/efb-backend/Cargo.lock
      - ./backend/migrations:/efb-backend/migrations
      - ./backend/exampledata.sql:/efb-backend/exampledata.sql
    environment:
      - ROCKET_DATABASES={logbook-db={url="postgres://efb:efb@postgres/logbook-db"}}
      - ROCKET_MAIL_SERVER="smtp.gmail.com"
      - ROCKET_MAIL_USER="efbtestetunseremails@gmail.com"
      - ROCKET_MAIL_PASSWORD="CK89eK4MTQQVMmA"
      - ROCKET_URL="https://reverent-gauss.82-165-78-90.plesk.page"
      - PGHOST=postgres
      - PGUSER=efb
      - PGPASSWORD=efb
      - PGPORT=5432
      - PGDATABASE=logbook-db
    depends_on:
      postgres:
        condition: service_healthy
    ports:
      - "8000:8000"
    command: sh -c "diesel setup &&
      diesel migration redo &&
      diesel print-schema > src/schema.rs &&
      psql -f exampledata.sql &&
      cargo watch -x run"

    # Replace with the following to display content of container work dir
    #command: ls -a
  next:
    container_name: next
    build: ./frontend
    volumes:
      - ./frontend:/workspace:cached
    command: sh -c "npm install && npm run dev"

  proxy:
    container_name: proxy
    image: nginx
    volumes:
      - ./auth/nginx:/etc/nginx/templates
    ports:
      - 8080:8080
    environment:
      - HOST_BACKEND=rocket
      - HOST_FRONTEND=next
    depends_on:
      - rocket
      - next
